//
// Created by lukas on 10.04.20.
//
#include "Arduino.h"

#define MINVOLTAGE 2.5
#define OHM 4.7

#define MEASUREPIN A3
#define MOSFETPIN A2

void setup() {
    Serial.begin(9600);
    pinMode(LED_BUILTIN, OUTPUT);
    pinMode(MOSFETPIN, OUTPUT);
    pinMode(MEASUREPIN, INPUT_PULLUP);

    digitalWrite(MOSFETPIN, LOW);
}

int i = 0;
double all = 0;

void loop() {
    Serial.println();
    double voltage = (float) (analogRead(MEASUREPIN)) / 1024 * 5;
    if (voltage > MINVOLTAGE && voltage < 4.5) {
        digitalWrite(MOSFETPIN, HIGH);
        double current = voltage / OHM;
        double watt = current * voltage;
        double amphours = current / 360; // every 10secs is a measurement point...
        all += amphours;
        Serial.print(all * 1000, 5);
        Serial.print("mA/h already captured after - ");
        Serial.print(i * 10);
        Serial.println("s");

        Serial.print("Watts: ");
        Serial.println(watt);
        Serial.print("Current: ");
        Serial.println(current);
        i++;
    } else if (voltage <= MINVOLTAGE) {
        digitalWrite(MOSFETPIN, LOW);
        Serial.print("FINISHED voltage below minvoltage - ");
        Serial.print(all * 1000, 5);
        Serial.print("mA/h in - ");
        Serial.print(i * 10);
        Serial.println("s");
        Serial.println("please restart the print");
        delay(999999999);
    } else if (voltage > 4.2) {
        Serial.println("no battery connected!");
    }
    Serial.print("Voltage: ");
    Serial.println(voltage);

    delay(10000);
}